// Code generated by client-gen. DO NOT EDIT.

package v1beta2

import (
	"net/http"

	rest "k8s.io/client-go/rest"
	"open-cluster-management.io/api/client/cluster/clientset/versioned/scheme"
	v1beta2 "open-cluster-management.io/api/cluster/v1beta2"
)

type ClusterV1beta2Interface interface {
	RESTClient() rest.Interface
	ManagedClusterSetsGetter
	ManagedClusterSetBindingsGetter
}

// ClusterV1beta2Client is used to interact with features provided by the cluster.open-cluster-management.io group.
type ClusterV1beta2Client struct {
	restClient rest.Interface
}

func (c *ClusterV1beta2Client) ManagedClusterSets() ManagedClusterSetInterface {
	return newManagedClusterSets(c)
}

func (c *ClusterV1beta2Client) ManagedClusterSetBindings(namespace string) ManagedClusterSetBindingInterface {
	return newManagedClusterSetBindings(c, namespace)
}

// NewForConfig creates a new ClusterV1beta2Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*ClusterV1beta2Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new ClusterV1beta2Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*ClusterV1beta2Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &ClusterV1beta2Client{client}, nil
}

// NewForConfigOrDie creates a new ClusterV1beta2Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *ClusterV1beta2Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new ClusterV1beta2Client for the given RESTClient.
func New(c rest.Interface) *ClusterV1beta2Client {
	return &ClusterV1beta2Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1beta2.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *ClusterV1beta2Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
